Redirect Сhains

‌‌
Redirect chains occur when there are at least two redirects between the initial URL and the destination URL. For example, if page A redirects to page B which redirects to page C, such a series of redirects is considered a redirect chain. Sometimes, if page B redirects back to page A, the redirect chain becomes closed and is considered a redirect loop.

This endpoint will provide you with a full list of redirect URLs that form redirect chains. Using the Redirect Сhains endpoint, you’ll be able to quickly identify and trace down multiple redirects issues.

checked POST
Pricing

Your account will not be charged for using this function. You can get the results of the task within the next 30 days for free.
The cost can be calculated on the Pricing page.

All POST data should be sent in the JSON format (UTF-8 encoding). The task setting is done using the POST method. When setting a task, you should send all task parameters in the task array of the generic POST array.

Description of the fields for setting a task:

Field nameTypeDescription
idstring

ID of the task
required field
you can get this ID in the response of the Task POST endpoint
example:
"07131248-1535-0216-1000-17384017ad04"

urlstring

page URL
optional field
absolute URL of the target page
if you use this field, the API response will return only redirect chains which contain the specified URL

limitinteger

the maximum number of returned redirect chains
optional field
default value: 100
maximum value: 1000

offsetinteger

offset in the results array of returned redirect chains
optional field
default value: 0
maximum value: 2000000
if you specify the 10 value, the first ten redirect chains in the results array will be omitted and the data will be provided for the successive redirect chains

filtersarray

array of results filtering parameters
optional field
you can use only one filtering parameter with this endpoint

the following filtering parameter is supported:
is_redirect_loop
the following operators are supported:
regex, not_regex, =, <>

examples:
["is_redirect_loop","=","true"]

["is_redirect_loop","<>","false"]

tagstring

user-defined task identifier
optional field
the character limit is 255
you can use this parameter to identify the task and match it with the result
you will find the specified tag value in the data object of the response


As a response of the API server, you will receive JSON-encoded data containing a tasks array with the information specific to the set tasks.

Description of the fields in the results array:

Field nameTypeDescription
versionstring

the current version of the API

status_codeinteger

general status code
you can find the full list of the response codes here
Note: we strongly recommend designing a necessary system for handling related exceptional or error conditions

status_messagestring

general informational message
you can find the full list of general informational messages here

timestring

execution time, seconds

costfloat

total tasks cost, USD

tasks_countinteger

the number of tasks in the tasks array

tasks_errorinteger

the number of tasks in the tasks array returned with an error

tasksarray

array of tasks

    idstring

task identifier
unique task identifier in our system in the UUID format

    status_codeinteger

status code of the task
generated by DataForSEO; can be within the following range: 10000-60000
you can find the full list of the response codes here

    status_messagestring

informational message of the task
you can find the full list of general informational messages here

    timestring

execution time, seconds

    costfloat

cost of the task, USD

    result_countinteger

number of elements in the result array

    patharray

URL path

    dataobject

contains the same parameters that you specified in the POST request

    resultarray

array of results

        crawl_progressstring

status of the crawling session
possible values: in_progress, finished

        crawl_statusobject

details of the crawling session

            max_crawl_pagesinteger

maximum number of pages to crawl
indicates the max_crawl_pages limit you specified when setting a task

            pages_in_queueinteger

number of pages that are currently in the crawling queue

            pages_crawledinteger

number of crawled pages

        total_items_countinteger

total number of relevant items in the database

        items_countinteger

number of items in the results array

        itemsarray

items array

            is_redirect_loopbool

indicates if redirects in chain start and end at the same URL
if true, the last URL from the chain redirects back to the original URL

            chainarray

contains links that form a chain

                typestring

type of the link = 'redirect'
HTTP redirect with 3xx status code

                domain_fromstring

referring domain
the link was found on this domain

                domain_tostring

referenced domain
the link is pointing to this domain

                page_fromstring

referring page
relative URL of the page on which the link was found

                page_tostring

referenced page
relative URL of the page to which the link is pointing

                link_fromstring

referring page
absolute URL of the page on which the link was found

                link_tostring

referenced page
absolute URL of the page to which the link is pointing

                dofollowboolean

indicates whether the link is dofollow
if the value is true, the link doesn't have a rel="nofollow" attribute

                page_from_schemestring

url scheme of the referring page

                page_to_schemestring

url scheme of the referenced page

                directionstring

direction of the link
possible values: internal, external

                is_brokenboolean

link is broken
indicates whether a link is directing to a broken page or resource

                is_link_relation_conflictboolean

indicates that the link may have a conflict with another link
if true, at least one link pointing to the URL in link_to has a rel="nofollow" attribute and at least one is dofollow


‌‌

Instead of ‘login’ and ‘password’ use your credentials from https://app.dataforseo.com/api-access

# Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access 
login="login" 
password="password" 
cred="$(printf ${login}:${password} | base64)" 
curl --location --request POST "https://api.dataforseo.com/v3/on_page/redirect_chains" 
--header "Authorization: Basic ${cred}"  
--header "Content-Type: application/json" 
--data-raw '[
  {
    "id": "03051327-4536-0216-1000-3b458a2cfcca",
    "url": "https://test_rdr.dataforseo.com/a/"
  }
]'
<?php
// You can download this file from here https://cdn.dataforseo.com/v3/examples/php/php_RestClient.zip
require('RestClient.php');
$api_url = 'https://api.dataforseo.com/';
// Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access
$client = new RestClient($api_url, null, 'login', 'password');
$post_array = array();
// simple way to get a result
$post_array[] = array(
   "id" => "03051327-4536-0216-1000-3b458a2cfcca",
   "url" => "https://test_rdr.dataforseo.com/a/"
);
try {
   // POST /v3/on_page/redirect_chains
   // the full list of possible parameters is available in documentation
   $result = $client->post('/v3/on_page/redirect_chains', $post_array);
   print_r($result);
   // do something with post result
} catch (RestClientException $e) {
   echo "n";
   print "HTTP code: {$e->getHttpCode()}n";
   print "Error code: {$e->getCode()}n";
   print "Message: {$e->getMessage()}n";
   print  $e->getTraceAsString();
   echo "n";
}
$client = null;
?>
const post_array = [];
post_array.push({
  id = "03051327-4536-0216-1000-3b458a2cfcca",
  url = "https://test_rdr.dataforseo.com/a/"
});
const axios = require('axios');
axios({
  method: 'post',
  url: 'https://api.dataforseo.com/v3/on_page/redirect_chains',
  auth: {
    username: 'login',
    password: 'password'
  },
  data: post_array,
  headers: {
    'content-type': 'application/json'
  }
}).then(function (response) {
  var result = response['data']['tasks'];
  // Result data
  console.log(result);
}).catch(function (error) {
  console.log(error);
});
from random import Random
from client import RestClient
# You can download this file from here https://api.dataforseo.com/v3/_examples/python/_python_Client.zip
client = RestClient("login", "password")
post_data = dict()
# simple way to get a result
post_data[len(post_data)] = dict(
    id="03051327-4536-0216-1000-3b458a2cfcca",
    url="https://test_rdr.dataforseo.com/a/"
)
# POST /v3/on_page/redirect_chains
# the full list of possible parameters is available in documentation
response = client.post("/v3/on_page/redirect_chains", post_data)
# you can find the full list of the response codes here https://docs.dataforseo.com/v3/appendix/errors
if response["status_code"] == 20000:
    print(response)
    # do something with result
else:
    print("error. Code: %d Message: %s" % (response["status_code"], response["status_message"]))
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Text;
using System.Threading.Tasks;
namespace DataForSeoDemos
{
    public static partial class Demos
    {
        public static async Task on_page_redirect_chains()
        {
            var httpClient = new HttpClient
            {
                BaseAddress = new Uri("https://api.dataforseo.com/"),
                // Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access
                DefaultRequestHeaders = { Authorization = new AuthenticationHeaderValue("Basic", Convert.ToBase64String(Encoding.ASCII.GetBytes("login:password"))) }
            };
            var postData = new List<object>();
            // simple way to get a result
            postData.Add(new
            {
                id = "03051327-4536-0216-1000-3b458a2cfcca",
                url = "https://test_rdr.dataforseo.com/a/"
            });
            // POST /v3/on_page/redirect_chains
            // the full list of possible parameters is available in documentation
            var taskPostResponse = await httpClient.PostAsync("/v3/on_page/redirect_chains", new StringContent(JsonConvert.SerializeObject(postData)));
            var result = JsonConvert.DeserializeObject<dynamic>(await taskPostResponse.Content.ReadAsStringAsync());
            // you can find the full list of the response codes here https://docs.dataforseo.com/v3/appendix/errors
            if (result.status_code == 20000)
            {
                // do something with result
                Console.WriteLine(result);
            }
            else
                Console.WriteLine($"error. Code: {result.status_code} Message: {result.status_message}");
        }
    }
}

The above command returns JSON structured like this:

{
  "version": "0.1.20210622",
  "status_code": 20000,
  "status_message": "Ok.",
  "time": "2.9408 sec.",
  "cost": 0,
  "tasks_count": 1,
  "tasks_error": 0,
  "tasks": [
    {
      "id": "07061451-2692-0216-1000-33d5e1cf58cd",
      "status_code": 20000,
      "status_message": "Ok.",
      "time": "2.8536 sec.",
      "cost": 0,
      "result_count": 1,
      "path": [
        "v3",
        "on_page",
        "redirect_chains"
      ],
      "data": {
        "api": "on_page",
        "function": "redirect_chains",
        "url": "https://test_rdr.dataforseo.com/a/"
      },
      "result": [
        {
          "crawl_progress": "finished",
          "crawl_status": {
            "max_crawl_pages": 5,
            "pages_in_queue": 0,
            "pages_crawled": 5
          },
          "total_items_count": 1,
          "items_count": 1,
          "items": [
            {
              "is_redirect_loop": false,
              "chain": [
                {
                  "type": "redirect",
                  "domain_from": "test_rdr.dataforseo.com",
                  "domain_to": "test_rdr.dataforseo.com",
                  "page_from": "/a/",
                  "page_to": "/b/",
                  "link_from": "https://test_rdr.dataforseo.com/a/",
                  "link_to": "https://test_rdr.dataforseo.com/b/",
                  "dofollow": true,
                  "page_from_scheme": "https",
                  "page_to_scheme": "https",
                  "direction": "internal",
                  "is_broken": false,
                  "is_link_relation_conflict": false
                },
                {
                  "type": "redirect",
                  "domain_from": "test_rdr.dataforseo.com",
                  "domain_to": "test_rdr.dataforseo.com",
                  "page_from": "/b/",
                  "page_to": "/c/",
                  "link_from": "https://test_rdr.dataforseo.com/b/",
                  "link_to": "https://test_rdr.dataforseo.com/c/",
                  "dofollow": true,
                  "page_from_scheme": "https",
                  "page_to_scheme": "https",
                  "direction": "internal",
                  "is_broken": false,
                  "is_link_relation_conflict": false
                },
                {
                  "type": "redirect",
                  "domain_from": "test_rdr.dataforseo.com",
                  "domain_to": "test_rdr.dataforseo.com",
                  "page_from": "/c/",
                  "page_to": "/test_chain.html",
                  "link_from": "https://test_rdr.dataforseo.com/c/",
                  "link_to": "https://test_rdr.dataforseo.com/test_chain.html",
                  "dofollow": true,
                  "page_from_scheme": "https",
                  "page_to_scheme": "https",
                  "direction": "internal",
                  "is_broken": false,
                  "is_link_relation_conflict": false
                }
              ]
            }
          ]
        }
      ]
    }
  ]
}